﻿let PushQueueElementBlockContentHandler = {

    initializePushQueueElementModal: function () {

        this.initializeBlockFooter();

        let pushQueueElementPropertiesElement = document.getElementById("pushQueueElementProperties");

        while (modalBlockParametersElement.lastElementChild) {
            modalBlockParametersElement.lastElementChild.style.display = "none";
            modalParametersContainerElement.appendChild(modalBlockParametersElement.lastElementChild);
        }

        modalBlockParametersElement.appendChild(pushQueueElementPropertiesElement);
        pushQueueElementPropertiesElement.style.display = "block";

        let valueInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=value]");
        ParametersInTextHelper.applyTagify(valueInputElement);

        if (selectedBlock.userData) {
            let queueNameInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=queueName]");
            let priorityInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=priority]");
            let postponeDateInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=postponeDate]");
            let deadlineDateInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=deadlineDate]");
            let commentInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=comment]");
            let referenceInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=reference]");
            let isReferenceUniqueInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=isReferenceUnique]");
            let slaTotalInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=slaTotal]");

            if (selectedBlock.userData.queueName)
                queueNameInputElement.value = selectedBlock.userData.queueName;
            else
                queueNameInputElement.selectedIndex = 0;

            if (selectedBlock.userData.value)
                valueInputElement.value = selectedBlock.userData.value;
            else
                valueInputElement.value = "";

            if (selectedBlock.userData.priority)
                priorityInputElement.value = selectedBlock.userData.priority;
            else
                priorityInputElement.value = 1;

            if (selectedBlock.userData.postponeDate)
                postponeDateInputElement.value = selectedBlock.userData.postponeDate;
            else
                postponeDateInputElement.value = null;

            if (selectedBlock.userData.deadlineDate)
                deadlineDateInputElement.value = selectedBlock.userData.deadlineDate;
            else
                deadlineDateInputElement.value = null;

            if (selectedBlock.userData.comment)
                commentInputElement.value = selectedBlock.userData.comment;
            else commentInputElement.value = null;

            if (selectedBlock.userData.reference)
                referenceInputElement.value = selectedBlock.userData.reference;
            else
                referenceInputElement.value = null;

            if (selectedBlock.userData.isReferenceUnique)
                isReferenceUniqueInputElement.checked = selectedBlock.userData.isReferenceUnique;
            else
                isReferenceUniqueInputElement.checked = false;

            if (selectedBlock.userData.slaTotal)
                slaTotalInputElement.value = selectedBlock.userData.slaTotal;
            else
                slaTotalInputElement.value = null;
        }
    },

    initializeBlockFooter: function () {
        let saveBtn = document.createElement("button");
        saveBtn.className = "modal-blackButton";
        saveBtn.style.width = "50%";
        saveBtn.innerHTML = localizedSaveChangesString;

        saveBtn.onclick = function () {
            modal.style.display = "none";
            PushQueueElementBlockContentHandler.saveQueueProperties();

            validateProcessScheme(null);
        }

        while (modalFooter.firstChild) {
            modalFooter.removeChild(modalFooter.firstChild);
        }
        modalFooter.appendChild(saveBtn);
    },

    saveQueueProperties: function () {
        let pushQueueElementPropertiesElement = document.getElementById("pushQueueElementProperties");

        let queueNameInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=queueName]");
        let valueInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=value]");
        let priorityInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=priority]");
        let postponeDateInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=postponeDate]");
        let deadlineDateInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=deadlineDate]");
        let commentInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=comment]");
        let referenceInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=reference]");
        let isReferenceUniqueInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=isReferenceUnique]");
        let slaTotalInputElement = pushQueueElementPropertiesElement.querySelector("[data-purpose=slaTotal]");

        selectedBlock.userData.blockName = blockNameInputElement.value;

        selectedBlock.userData.queueName = queueNameInputElement.value;
        selectedBlock.userData.value = valueInputElement.value;
        selectedBlock.userData.priority = priorityInputElement.value;
        selectedBlock.userData.postponeDate = postponeDateInputElement.value;
        selectedBlock.userData.deadlineDate = deadlineDateInputElement.value;
        selectedBlock.userData.comment = commentInputElement.value;
        selectedBlock.userData.reference = referenceInputElement.value;
        selectedBlock.userData.isReferenceUnique = isReferenceUniqueInputElement.checked;
        selectedBlock.userData.slaTotal = slaTotalInputElement.value;

        setBlockNameLabel(selectedBlock, "blockName", blockNameInputElement.value);
    }

}