﻿
// Генерирует и добавляет div-ы с соответствующими сообщениями
function addAlertMessage(text, divId, alertType) {

    let containerDiv = document.getElementById(divId);
    let div = document.createElement('div');

    if (alertType === 'success') {
        div.className = "alert alert-success alert-dismissible";
    }
    else if (alertType === 'danger') {
        div.className = "alert alert-danger alert-dismissible";
    }
    else if (alertType === 'warning') {
        div.className = "alert alert-warning alert-dismissible";
    }
    else if (alertType === 'info') {
        div.className = "alert alert-info alert-dismissible";
    }

    div.innerText = text;

    let a = document.createElement('a');
    a.href = '#';
    a.className = 'close';
    a.setAttribute('data-dismiss', 'alert');
    a.setAttribute('aria-label', 'close')
    a.innerText = 'x';


    containerDiv.appendChild(div);
    div.appendChild(a);
}