﻿let QueueDistributorBlockContentHandler = {

    previousBlockParameters: {},

    initializeQueueDistributorModal: function () {

        this.initializeBlockFooter();

        QueueDistributorBlockContentHandler.previousBlockParameters = getPreviousBlockParameters();
       
        //this.getSelectionParameter();
        let previousBlockParametersSelectList = formPreviousBlockParametersSelectList(this.previousBlockParameters);
        console.log(previousBlockParametersSelectList);

 

        let queueDistributorPropertiesElement = document.getElementById("queueDistributorProperties");

        while (modalBlockParametersElement.lastElementChild) {
            modalBlockParametersElement.lastElementChild.style.display = "none";
            modalParametersContainerElement.appendChild(modalBlockParametersElement.lastElementChild);
        }

        modalBlockParametersElement.appendChild(queueDistributorPropertiesElement);
        queueDistributorPropertiesElement.style.display = "block";

        if (selectedBlock.userData) {
            let queueNameInputElement = queueDistributorPropertiesElement.querySelector("[data-purpose=queueName]");
            let taskNameInputElement = queueDistributorPropertiesElement.querySelector("[data-purpose=taskName]");
            let paramNameElement = queueDistributorPropertiesElement.querySelector("[data-purpose=paramName]");

            paramNameElement.innerHTML = previousBlockParametersSelectList.innerHTML;
          
            if (selectedBlock.userData.queueName)
                queueNameInputElement.value = selectedBlock.userData.queueName;
            else
                queueNameInputElement.selectedIndex = 0;

            if (selectedBlock.userData.taskName)
                taskNameInputElement.value = selectedBlock.userData.taskName;
            else
                taskNameInputElement.selectedIndex = 0;

            console.log(selectedBlock.userData)

            if (selectedBlock.userData.paramName)
                paramNameElement.value = selectedBlock.userData.paramName;
            else
                paramNameElement.selectedIndex = 0;
        }
    },

    initializeBlockFooter: function () {
        let saveBtn = document.createElement("button");
        saveBtn.className = "modal-blackButton";
        saveBtn.style.width = "50%";
        saveBtn.innerHTML = localizedSaveChangesString;

        saveBtn.onclick = function () {
            modal.style.display = "none";
            QueueDistributorBlockContentHandler.saveQueueNameProperties();

            validateProcessScheme(null);
        }

        while (modalFooter.firstChild) {
            modalFooter.removeChild(modalFooter.firstChild);
        }
        modalFooter.appendChild(saveBtn);
    },

    saveQueueNameProperties: function () {
        let queueDistributorPropertiesElement = document.getElementById("queueDistributorProperties");

        let queueNameElement = queueDistributorPropertiesElement.querySelector("[data-purpose=queueName]");
        let taskNameElement = queueDistributorPropertiesElement.querySelector("[data-purpose=taskName]");
        let paramNameElement = queueDistributorPropertiesElement.querySelector("[data-purpose=paramName]");

 
        selectedBlock.userData.blockName = blockNameInputElement.value;
        selectedBlock.userData.queueName = queueNameElement.value;
        selectedBlock.userData.taskName = taskNameElement.value;
        selectedBlock.userData.paramName = paramNameElement.value;

       setBlockNameLabel(selectedBlock, "queueDistributorName", blockNameInputElement.value);
    }
}