﻿
var selectedBlock = undefined;

var locatorAttributeNames = ["x", "y", "margin"];

// Get the modal
var modal = document.getElementById("blockModal");

var modalFooter = document.getElementById("modalBlockFooter");

var modalBlockParametersElement = document.getElementById("modalBlockParameters");

var modalParametersContainerElement = document.getElementById("modalParametersContainer");

var blockNameInputElement = document.getElementById("blockName");

// Get the <span> element that closes the modal
var span = document.getElementsByClassName("close")[0];

// When the user dblclicks the block, open the modal
function showModal(block) { 
    selectedBlock = block;
    modal.style.display = "block";

    document.getElementById("blockIdLabel").innerText = selectedBlock.getId();
    blockNameInputElement.value = selectedBlock.userData.blockName;

    selectedBlock.unselect();
}

// When the user clicks on <span> (x), close the modal
span.onclick = function () {
    modal.style.display = "none";
}

// When the user clicks anywhere outside of the modal, close it
window.onmousedown = function (event) {
    if (event.target == modal) {
        modal.style.display = "none";
    }
}