﻿function addCalendarStartTimeRow(containerId, timeValue) {
    let containerElement = document.getElementById(containerId);

    let timeInputRowElement = document.createElement("tr");

    let timeInputElement = document.createElement("input");
    timeInputElement.type = "time";
    timeInputElement.className = "form-control";
    timeInputElement.required = true;

    if (timeValue) {
        timeInputElement.value = timeValue;
    }

    let timeInputCellElement = document.createElement("td");
    timeInputCellElement.appendChild(timeInputElement);
    timeInputRowElement.append(timeInputCellElement);

    let deleteRowButton = document.createElement("input");
    deleteRowButton.type = "button";
    deleteRowButton.className = "btn btn-secondary";
    deleteRowButton.value = "X";
    deleteRowButton.onclick = function () { deleteTimeRow(deleteRowButton); };

    let deleteRowCellElement = document.createElement("td");
    deleteRowCellElement.appendChild(deleteRowButton);

    timeInputRowElement.append(deleteRowCellElement);

    containerElement.appendChild(timeInputRowElement);
}

function deleteTimeRow(buttonElement) {
    $(buttonElement).closest("tr").remove();
}

function fillCalendarStartTimes(timeRowsContainerId) {
    let calendarTimesInputElement = document.getElementById("ScheduleType_CalendarStartTimes");

    let timeRowsContainerElement = document.getElementById(timeRowsContainerId);

    let timeInputElements = timeRowsContainerElement.querySelectorAll("input[type='time']");
    let timeValues = Array.from(timeInputElements).map(m => m.value).filter(f => f && f.length > 0);

    calendarTimesInputElement.value = timeValues.join(",");
}